#include "StdAfx.h"
#include "SDK.h"
#include "CritSection.h"
#include "Global.h"

ThreadSection g_csTask;
std::list<STMid> CSDK::m_vtMidTask;

CSDK::CSDK(void)
{
}

CSDK::~CSDK(void)
{
}

int CSDK::QueryMidInfo(std::string order)
{
	return 0;
}

int CSDK::DownloadMidData(std::string order)
{
	return 0;
}

int CSDK::QueryKeyInfo(std::string sn)
{
	return 0;
}

int CSDK::UpdateKeyCopyStatus(std::string sn)
{
	return 0;
}

int CSDK::UpdateKeyReportStatus(std::string sn)
{
	return 0;
}

int CSDK::ReportKeyCopyResults(std::string sn /* = "" */)
{
	return 0;
}

void CSDK::AddDownloadTask(STMid &mid)
{
	AutoThreadSection ats(&g_csTask);
	bool has = false;
	std::list<STMid>::iterator it = m_vtMidTask.begin();
	for (; it != m_vtMidTask.end(); it++ )
	{
		if ( _tcsicmp(it->order.c_str(), mid.order.c_str()) == 0 )
		{
			has = true;
			*it = mid; // ;
			break;
		}
	}

	if ( !has )
	{
		m_vtMidTask.push_back(mid);
	}
}

BOOL CSDK::PopDownloadTask(STMid &mid)
{
	AutoThreadSection ats(&g_csTask);
	if ( m_vtMidTask.size() )
	{
		mid = m_vtMidTask.front();
		m_vtMidTask.pop_front();
		return TRUE;
	}

	return FALSE;
}

DWORD CSDK::ThreadDownload(LPVOID lpParam)
{
	CSDK *that = (CSDK*)lpParam;
	// keyļ·;
	TCHAR szKeyPacket[MAX_PATH] = {0};
	do 
	{
		// ȡ;
		STMid mid;
		if ( PopDownloadTask(mid) )
		{
			// жļǷڣmd5ֵ;
			_stprintf_s(szKeyPacket, _T("%s%s.json"), Global::g_szCurModuleDir, mid.order.c_str());
			if ( _taccess(szKeyPacket, 0) != -1 )
			{
				// Уļmd5ֵ;
			}
			else
			{
				// ļ,ʼ;
			}
		}
	} while (WaitForSingleObject(that->m_hDownloadEvent, 3000) == WAIT_TIMEOUT );

	return 0L;
}

DWORD CSDK::ThreadReport(LPVOID lpParam)
{
	CSDK *that = (CSDK*)lpParam;
	do 
	{
		// Զϱ;

	} while (WaitForSingleObject(that->m_hReportEvent, 3000) == WAIT_TIMEOUT );

	return 0L;
}