#ifndef __SDK_HEADER__
#define __SDK_HEADER__

#pragma once

#include "TableInfo.h"

class CSDK
{
public:
	CSDK(void);
	~CSDK(void);

public:
	int QueryMidInfo(std::string order);
	int DownloadMidData(std::string order);
	int QueryKeyInfo(std::string sn);
	int UpdateKeyCopyStatus(std::string sn);
	int UpdateKeyReportStatus(std::string sn);
	int ReportKeyCopyResults(std::string sn = "");

private:
	static std::list<STMid> m_vtMidTask;
	static void AddDownloadTask(STMid &mid);
	static BOOL PopDownloadTask(STMid &mid);

	
	HANDLE m_hDownloadEvent;
	HANDLE m_hThreadDownload;
	static DWORD WINAPI ThreadDownload(LPVOID lpParam);

	HANDLE m_hReportEvent;
	HANDLE m_hThreadReport;
	static DWORD WINAPI ThreadReport(LPVOID lpParam);
};

#endif